//+------------------------------------------------------------------+
//|                                                        AshFx.mq4 |
//|                                                    Steve Hopwood |
//|                                     www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Steve Hopwood"
#property link      "www.hopwood3.freeserve.co.uk"
//#include <WinUser32.mqh>//Not needed because LibOrderReliable includes them
//#include <stdlib.mqh>
#include <LibOrderReliable.mqh>
#define  NL    "\n"
#define GlobalPrefix "AshFX" //Used for prefixing all objects created by this EA. Re-define to suit the robot.


/*
void DisplayUserFeedback()
int start()
double SetPointSize()
bool SendSingleTrade(int type)
      Use construct bool TradeSuccess = SendSingleTrade(int type);
void CalculateTpSl(int type)
double ReadStochastic()
      Use construct double StochVal = ReadStochastic()
bool DoesTradeExist()
      Use construct bool TradeExists = DoesTradeExist();
void TradesTotal()
bool CheckFilters(int type)
bool CheckForGlobalVariable()
bool CheckGvStillValid()
bool HasSarsChangedDirection()
bool CheckOpenTradeStillOk(int type)
bool CloseExistingTrade(int type)
bool NewsFilterCheck()
string Num2Impact(int impact)
void CloseProfitableTradeBeforeNews()
void SetUpGolbalVariablesDisplay()
void AutoCalculateLotSize()
bool ShouldRobotSleep()

********Higher trade filters*********** 
void ReturnMacdTrend()
void ReturnPsarTrend()


********Fibonacci functions***********
Thanks to Tim and Craig at FXAW for all this
void Calc_FiboPivots()
void DrawFiboLines()
void CreateLine(string name,datetime tfrom, datetime tto, double pfrom, double pto, color Col, int width)
void CreateText(string TextName, string LabelText, double Price, color TextColor)
void DeleteEAObjects(string ObjName)
void GetCurrentFibBand()

********Management functions***********
void ManageTrade()
void MonitorTrades()
void SetAGlobalTicketVariable()
int GetNextAvailableVariableNumber()
void JumpingStopLoss() 
bool PartCloseTradeFunction()
void BreakEvenStopLoss() 
void TryPartCloseAgain()


Description of the strategy this robot trades
Dear All,
I hereby present to you the AshFX Daily System, Version II.
This system is simple, easy, & profitable.
AshFX V2 uses the following indicators:


-Parabolic SAR (0.05, 0.2)
-AC (Accelerator Oscillator)
-AO (Awesome Oscillator)
-Stochastics (5,3,3)


Take the attached template and apply it in Metatrader. The system is suited for the Daily System, but it can also 
be used on H4, and on any currency pair. Here is an example of what you should be seeing: 

Now I will outline how the system actually works: 

ENTRY 

Sell: When the first PSAR dot appears above the candle, AND stochastic is crossing down but is not 
oversold (i.e. not below the 20 line), AND the AC is red, AND the AO is red, AND candle is red (bearish 
candle). Only enter once the candle has fully closed. 

Buy: When the first PSAR dot appears below the candle, AND stochastic is crossing up but is not 
overbought (i.e. not above the 80 line), AND the AC is green, AND the AO is green, AND candle is green 
(bullish candle). Only enter once the candle has fully closed. 

EXIT 

Initial Stop Loss is at the swing high for short trades, and swing low for long trades. 

If the day, or any consequent day, has closed in your direction (i.e. youre in profit at the end of any given 
day), then close half your position & move SL to break even. Close the other half once either the AO or 
PSAR turns the opposite colour/direction. Only exit at the candle close. 

Final Points 

Please bear in mind, it doesnt matter in which order the indicators line up, just as long as the rules 
mentioned above are adhered to. Also, (and this goes without saying), its important to pay attention to key 
Support & Resistance levels, in addition to price action. 

Happy trading! 
AshFX 
Email: ash@forexmoments.com 

Web: http://www.forexmoments.com 





OrderReliable.mqh
This template uses Matthew Kennel, Derk Wehler and Jack Tomlinson's LibOrderReliable library 
to send trade calls and modifications.
LibOrderReliable.mqh must go into the user's experts\include folder. 
LibOrderReliable.mq4 must go into the user's experts\libraries folder. 
My thanks to Matt, Derk and Jack for all their efforts in coding this invaluable resource.

These are the terms of use of the library, copied from the source code:
//	LICENSING:  This is free, open source software, licensed under
//				Version 2 of the GNU General Public License (GPL). 
// 
// In particular, this means that distribution of this software in a binary 
// format, e.g. as compiled in as part of a .ex4format, must be accompanied
// by the non-obfuscated source code of both this file, AND the .mq4 source 
// files which it is compiled with, or you must make such files available at 
// no charge to binary recipients.	If you do not agree with such terms you 
// must not use this code.  Detailed terms of the GPL are widely available 
// on the Internet.  The Library GPL (LGPL) was intentionally not used, 
// therefore the source code of files which link to this are subject to
// terms of the GPL if binaries made from them are publicly distributed or 
// sold. 
//  
// Copyright (2006), Matthew Kennel
// Copyright  2007, Derk Wehler     (derkwehler@gmail.com)
// Copyright  2007, Jack Tomlinson  (jack.tomlinson@gmail.com)
//
//===========================================================================


*/



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern string     GVI="-----General trade inputs-----";
extern double     Lot = 0.01;
extern int        MaxSpread=10;
extern string     TradeComment="AshFX Steve";
extern bool       TradeLong=true;
extern bool       TradeShort=true;
extern bool       BrokerIs2stageCrook=false;
extern int        Birthday;
extern int        SleepAfterTradeClosesMins=240;
extern string     mmi="--------------------------------------------";
extern string     mm2 = "-----Robot-calculated lot size-----";
extern bool       RobotCalcLotSize=false;  
extern double     RiskPercent=1;
extern string     il1="--------------------------------------------";
extern string     sltp="-----Stop loss and take profit-----";
extern int        TakeProfit = 250;
extern bool       AutoCalculateTakeProfit=false;
extern double     AtrPeriod=20;
extern int        AdxPeriod=14;
extern int        StopLoss=125;
extern bool       AutoCalculateStopLoss=false;
extern string     il2="--------------------------------------------";
extern string     ins31="-----Trading time filters-----";
extern bool       TradeSundayCandle=false;
extern int        MondayStartHour=3;
extern bool       StopTradingOnFriday=true;
extern int        FridayStopHour=14;
extern string     il3="--------------------------------------------";
extern string     f1="-----Trade filters-----";
extern bool       UseStochastic=true;
extern double     StochOverBought=80;
extern double     StochOverSold=20;
/*extern bool       UseVolume=false;
extern bool       UseMA=false;
extern int        FastMA=21;
extern int        SlowMA=89;
*/extern string     il4="--------------------------------------------";
extern string     news="-----News filter-----";
extern bool       UseNewsFilter=true;
extern int        MinsUntilNews=60;
//extern int        MinsAfterNews=60;//Code this if it turns out to be necessary
extern string     news1="3=High; 2=Medium; 1=Low";
extern int        NewsImpact=3;
extern bool       CloseProfitableTrade=false;
extern string     il30="--------------------------------------------";
/*extern string     fibi="-----Fib s\r settings-----";
extern bool       UseFibs=false;
extern int        MinPipsToNextLevel=30;
extern bool       Display.IntraDayHL = false;
extern color      Color.IntraDayHL = Yellow;
extern bool       Display.Fibos = false;
extern color      Color.Fibos = Yellow;
extern string     il6="--------------------------------------------";
extern string     htf="-----Higher trend filters-----";
extern string     macd="MACD settings";   
extern bool       UseMACD=false;
extern int        MacdLookBackBars = 5;
extern double     MinMacdValue = 0.0001;
extern string     psar="PSAR settings";
extern bool       UsePSAR=false;
extern int        PsarLookBackBars = 2;
extern string     il5="--------------------------------------------";
*/extern string     ins50="Trade management settings";
extern bool       EaManagesTrades=true;
extern string     slf="--Stop Loss & Take Profit Manipulation----";
extern string     BE="Break even settings";
extern bool       BreakEven=false;
extern int        BreakEvenPips=200;
extern int        BreakEvenProfit=20;
extern string     JSL="Jumping stop loss settings";
extern bool       JumpingStop=true;
extern int        JumpingStopPips=100;
extern bool       AddBEP=true;
extern bool       JumpAfterBreakevenOnly=false;
extern bool       PartCloseEnabled=false;
extern double     Close_Lots = 0.01;
extern double     Preserve_Lots=0.01;
extern string     il7="--------------------------------------------";
extern string     bab="----Bits and bats----";
extern bool       ShowAlerts=true;
extern int        DisplayGapSize=30;
extern string     CurrencySymbol="$";


// Fib variables
datetime          Prior_Time_D1;
double            yesterday_close,yesterday_high,yesterday_low;
double            IntradayPivot, IntradayLong, IntradayR1, IntradayHigh, IntradayLongT1, IntradayLongT2;
double            IntradayShort, IntradayS1, IntradayLow, IntradayShortT1, IntradayShortT2;
int               MinTradingRange=100;// Make this an extern if user choice is required
double            FibBandHigh, FibBandLow;//Fib levels that surround the market price
int               OldBars=0;

//Misc stuff
string            GvName; // Holds names of global variables
string            Gap, ScreenMessage;
string            TicketName = "ManagementGvTicketNo";
bool              ManagementGVsExist=false;
double            Tp, Sl; // For calculating take profit and stop loss
int               ReturnedTicketNo;// Ticket number returned during the DoesTradeExist function
double            TradesProfit;
double            TradesOpen;
double            Poin;// Replaces Point and allows for 5 decimal place brokers
int               TimePeriod;//For the chart time setting of higher trend filters
int               HigherTrendDirection;
int               MagicNumber=0;
bool              RobotDisabled=false;
int               MaxSpreadDisplay;//For displaying the max spread enterred by the user, before any multiplying is done to it

int init()
{
//----
   
   MaxSpreadDisplay=MaxSpread;//For display purpose
   
   //Set the Point size for this symbol, adjust for 5 digit if necessary
   Poin = SetPointSize();
   if (Digits == 3 || Digits == 5) MaxSpread*= 10;
   
   //Magic number, saved in a gv after the first time this robot is run
   string GName = StringConcatenate(GlobalPrefix, "MagicNumber");
   if (GlobalVariableCheck(GName))
   {
      MagicNumber = GlobalVariableGet(GName);
   }//if (GlobalVariableCheck(GvName))
   else//This is the first time the expers has run, so generate a mn
   {
      //Check validity of Birthday field
      if (Birthday == 0)
      {
         RobotDisabled=true;
         MessageBox("The robot cannot generate a magic number with the Birthday input = 0.", NL,"The robot is disabled.");
         Comment("                 Robot disabled until Birthday input is filled");
         return;
      }//if (Birthday == 0)
      
      MathSrand((TimeLocal() + TimeCurrent()) * Birthday);
      int mn = MathRand();
      MathSrand(mn);
      mn = MathRand();   
      MagicNumber = mn;
      string MnDisplay = StringConcatenate("Magic number for this expert is: ", DoubleToStr(MagicNumber,0));
      MessageBox(MnDisplay);
      GlobalVariableSet(GName, MagicNumber);
   }//else
   
   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }

   // Set up period if for higher filters
   if (Period() == PERIOD_M1) TimePeriod = PERIOD_M5;
   if (Period() == PERIOD_M5) TimePeriod = PERIOD_M15;
   if (Period() == PERIOD_M15) TimePeriod = PERIOD_M30;
   if (Period() == PERIOD_M30) TimePeriod = PERIOD_H1;
   if (Period() == PERIOD_H1) TimePeriod = PERIOD_H4;
   if (Period() == PERIOD_H4) TimePeriod = PERIOD_D1;
   if (Period() == PERIOD_D1) TimePeriod = PERIOD_W1;
   if (Period() == PERIOD_W1) TimePeriod = PERIOD_MN1;
   //if (Period() == PERIOD_MN1 && UseMACD) Alert("Cannot use higher time filter on the Monthly chart");
 
   if (OrdersTotal() > 0) TradesTotal();
   DisplayUserFeedback();
   
   GvName = StringConcatenate("AshFx", Symbol(),"TradePending");
   
   
   //start();
   
   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   DeleteEAObjects(GlobalPrefix);
   
//----
   return(0);
}

void DisplayUserFeedback()
{
   ScreenMessage="";
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "This EA is the copyright of Steve Hopwood.", NL);
   if (RobotCalcLotSize)
   {
      AutoCalculateLotSize();
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Robot is calculating the lot size", NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Lot size = ", Lot, NL);
   }//if (RobotCalcLotSize)
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot, NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Take profit is ",TakeProfit," pips",NL);
   if (AutoCalculateStopLoss)
   {
      CalculateTpSl(0);
      ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Auto-calculating Stop Loss at ", Sl,NL);
   }//if (AutoCalculateStopLoss)
   
   else ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Stop Loss is ",StopLoss," pips",NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Maximum spread is ",MaxSpreadDisplay," pips",NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Magic number = ", MagicNumber,NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TradeComment = ", TradeComment,NL);
   if (TradeLong && TradeShort) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lookng for long and short trades", NL);
   else
   {
      if (TradeLong) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lookng for long trades", NL);
      if (TradeShort) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lookng for short trades", NL);
   }
   if (!TradeLong && !TradeShort) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not looking for trades", NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "The robot will sleep for ", SleepAfterTradeClosesMins, " mins after a trade closure",NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trades opened by this EA = ", TradesOpen, ":  Upl = ", CurrencySymbol, TradesProfit,NL);
   if (UseStochastic) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using Stochastic filter",NL);
   /*if (UseVolume) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using Volumes filter",NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not using Volumes filter",NL);
   if (UseMA) 
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using MA filter",NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Slow MA = ", SlowMA, ": Fast MA = ", FastMA,NL);
   }//if (UseMa) 
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not using MA filter",NL);
   if (UseFibs)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using Fibonacci support and resistance levels",NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Next resistance is ", DoubleToStr(FibBandHigh,Digits), NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Next support is ", DoubleToStr(FibBandLow,Digits), NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Min pips to next level =  ", MinPipsToNextLevel, NL);
      }//if (UseFibs)
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not using Fibonacci support and resistance levels",NL);
   */
   if (UseNewsFilter) 
   {
      NewsFilterCheck();      
   }//if (UseNewsFilter)   
   
   //Higher trend filters
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Higher trend filters:",NL);
   /*if (UseMACD && Period() != PERIOD_MN1)
   {
      ReturnMacdTrend();
      if (HigherTrendDirection == 0) string direction = "Long";
      if (HigherTrendDirection == 1) direction = "Short";
      if (HigherTrendDirection == 2) direction = "No trend";
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     ", "MACD trend: ", direction, NL);
   }//if (UseMACD)
   
   if (UsePSAR && Period() != PERIOD_MN1)
   {
      ReturnPsarTrend();
      if (HigherTrendDirection == 0) direction = "Long";
      if (HigherTrendDirection == 1) direction = "Short";
      if (HigherTrendDirection == 2) direction = "No trend";
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     ", "PSAR trend: ", direction, NL);
   }//if (UsePSAR)
   */
   if (EaManagesTrades)
   {
      ScreenMessage=StringConcatenate(ScreenMessage, Gap, "EA trade management settings:",NL);

      if (BreakEven) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     Break even set to ",BreakEvenPips, " to lock in ", BreakEvenProfit, " pips",NL);
      if (JumpingStop) 
      {
         ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     Jumping stop set to ", JumpingStopPips, " pips: ");
         if (AddBEP) ScreenMessage=StringConcatenate(ScreenMessage, "AddBEP is set to ",BreakEvenProfit, " pips");
         if (JumpAfterBreakevenOnly) ScreenMessage=StringConcatenate(ScreenMessage, ": Jump will start after breakeven only");
         ScreenMessage=StringConcatenate(ScreenMessage,NL);
         if (PartCloseEnabled)
         {
            ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Trade part-close is enabled. Closing ",Close_Lots, ": Preserving ", Preserve_Lots,NL);
         }
      }//if (JumpingStop)
      
  
   }//if (EaManagesTrades)

   // Sunday candle
   if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal())==0) 
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended - Sunday candle. Continuing to manage open trades.",NL);         
   }//if (!TradeSundayCandle && TimeDayOfWeek(TimeCurrent())==0) 
   
   //Monday start
   if (TimeDayOfWeek(TimeLocal())==1 && TimeHour(TimeLocal()) < MondayStartHour)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended - too early on Monday. Continuing to manage open trades.",NL);         
   }//if (!TradeSundayCandle && TimeDayOfWeek(TimeCurrent())==0) 
   
   //Friday shut down
   if (StopTradingOnFriday)
   {
      if (TimeDayOfWeek(TimeLocal())==5)
      {   
         if (TimeHour(TimeLocal()) >= FridayStopHour)
         {
            ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Friday close. Continuing to manage open trades.",NL);
         }//if (TimeHour(TimeCurrent()) >= FridayStopHour)   
      }//if TimeDayOfWeek(TimeCurrent()==5)   
   }//if (StopTradingOnFriday)


   if (GlobalVariablesTotal() > 0)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Impending trades:",NL);
      SetUpGolbalVariablesDisplay();
   }//if (GlobalVariablesTotal > 0)
   

   Comment(ScreenMessage);

}// End void DisplayUserFeedback()

void SetUpGolbalVariablesDisplay()
{
   // Displays list of impending trades.
   // Heading is set up before calling this routine
   
      for (int cc = GlobalVariablesTotal(); cc >=0; cc--)
      {
         int index;
         string Name = GlobalVariableName(cc);
         
         index = StringFind(Name,"AshFx",0);
         if (index > -1)
         {
            int type = GlobalVariableGet(Name);
            if (type == 0) string TypeDisplay = ": Long";
            else TypeDisplay = ": Short";
            ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     ", Name,TypeDisplay,NL);      
         }//if (index>-1)
         
      }//for (cc = GlobalVariablesTotal(); cc >=0, cc--)
      
   
   
}//End void SetUpGolbalVariablesDisplay()

double SetPointSize()
{
   if ( Digits < 4 )
   {
      if( StringFind(Symbol(), "JPY", 0) != -1 ) return(0.01);
      else if( StringFind(Symbol(), "GOLD", 0) != -1 || StringFind(Symbol(), "gold", 0) != -1 || StringFind(Symbol(), "Gold", 0) != -1 )return(0.1);
      else return(0.01);
   }
   else return(0.0001);
}

/*void Calc_FiboPivots()
 {
  double rates[1][6];
  ArrayCopyRates(rates, Symbol(), PERIOD_D1);
  if(DayOfWeek() == 1)
   {
    if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
     {
      yesterday_close = rates[1][4];
      yesterday_high = rates[1][3];
      yesterday_low = rates[1][2];
     }
    else
     {
      for(int d = 5;d>=0;d--)
       {
        if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
         {
          yesterday_close = rates[d][4];
          yesterday_high = rates[d][3];
          yesterday_low = rates[d][2];
         }   
       } 
     }
   }
  else
   {
    yesterday_close = rates[1][4];
    yesterday_high = rates[1][3];
    yesterday_low = rates[1][2];
   }

   //---- Calculate Fib Based Pivots
   double R = (yesterday_high - yesterday_low) /2;
  
   /*int Multiplier;
   if (Digits == 5) Multiplier = 100000; //5 digits
   else if (Digits == 3) Multiplier = 1000; //3 digits (for Yen based pairs)   
   else if (Digits == 2) Multiplier = 100; //3 digits (for Yen based pairs)   
   else Multiplier = 10000; //Normal
   int Mrange = (R * 2) * Multiplier;
   */
   
   /*//Checking sufficiently wide trading range
   IntradayPivot  = NormalizeDouble((yesterday_high + yesterday_low)/2,Digits); //Mine. works
   IntradayLong = NormalizeDouble(IntradayPivot + (R * 0.25),Digits);
   IntradayR1 = NormalizeDouble(IntradayPivot + (R * 0.618),Digits);
   IntradayHigh = yesterday_high;
   IntradayLongT1 = NormalizeDouble(IntradayPivot + (R * 1.75),Digits);
   IntradayLongT2 = NormalizeDouble(IntradayPivot + (R * 2.25),Digits);
   IntradayShort = NormalizeDouble(IntradayPivot - (R * 0.25),Digits);
   IntradayS1 = NormalizeDouble(IntradayPivot - (R * 0.618),Digits);
   IntradayLow = yesterday_low;
   IntradayShortT1 = NormalizeDouble(IntradayPivot - (R * 1.75),Digits);
   IntradayShortT2 = NormalizeDouble(IntradayPivot - (R * 2.25),Digits);
  
    
   return;
 }// End void Calc_FiboPivots()

void DrawFiboLines()
{
   DeleteEAObjects(GlobalPrefix + "L"); //Ensure all previous Line Objects are deleted

   
   if(Display.IntraDayHL )
   {
      int StartTime;
      if(TimeDayOfWeek(TimeCurrent()) == 1) StartTime = 2;
      else StartTime = 1;
      CreateLine(GlobalPrefix + "LIDHI1",Time[StartTime], Time[0],yesterday_high,yesterday_high,Color.IntraDayHL,1); 
      string DisplayPrice = StringConcatenate("Intraday High ", yesterday_high);
      CreateText(GlobalPrefix + "LPDHI2", DisplayPrice, yesterday_high, Color.IntraDayHL);

      CreateLine(GlobalPrefix + "LIDLO1",Time[StartTime], Time[0],yesterday_low,yesterday_low,Color.IntraDayHL,1); 
      DisplayPrice = StringConcatenate("Intraday Low ", yesterday_low);
      CreateText(GlobalPrefix + "LIDLO2", DisplayPrice, yesterday_low, Color.IntraDayHL);
   }

   if(Display.Fibos )
   {
      CreateLine(GlobalPrefix + "LIDP1",Time[StartTime], Time[0],IntradayPivot,IntradayPivot,Color.IntraDayHL,1); 
      DisplayPrice = StringConcatenate("Intraday Pivot ", IntradayPivot);
      CreateText(GlobalPrefix + "LIDP2", DisplayPrice, IntradayPivot, Color.IntraDayHL);
            
      CreateLine(GlobalPrefix + "LIDL1",Time[StartTime], Time[0],IntradayLong,IntradayLong,Color.Fibos,1); 
      DisplayPrice = StringConcatenate("Intraday Long ", IntradayLong);
      CreateText(GlobalPrefix + "LIDL2", DisplayPrice, IntradayLong, Color.Fibos);

      CreateLine(GlobalPrefix + "LIDR1",Time[StartTime], Time[0],IntradayR1,IntradayR1,Color.Fibos,1); 
      DisplayPrice = StringConcatenate("Intraday R1 ", IntradayR1);
      CreateText(GlobalPrefix + "LIDR2", DisplayPrice, IntradayR1, Color.Fibos);

      CreateLine(GlobalPrefix + "LIDLT11",Time[StartTime], Time[0],IntradayLongT1,IntradayLongT1,Color.Fibos,1);
      DisplayPrice = StringConcatenate("Intraday Long T1 ", IntradayLongT1);
      CreateText(GlobalPrefix + "LIDLT12", DisplayPrice, IntradayLongT1, Color.Fibos);

      CreateLine(GlobalPrefix + "LIDLT21",Time[StartTime], Time[0],IntradayLongT2,IntradayLongT2,Color.Fibos,1);
      DisplayPrice = StringConcatenate("Intraday Long T2 ", IntradayLongT2);
      CreateText(GlobalPrefix + "LIDLT22", DisplayPrice, IntradayLongT2, Color.Fibos);

      CreateLine(GlobalPrefix + "LIDS1",Time[StartTime], Time[0],IntradayShort,IntradayShort,Color.Fibos,1);
      DisplayPrice = StringConcatenate("Intraday Short ", IntradayShort);
      CreateText(GlobalPrefix + "LIDS2", DisplayPrice, IntradayShort, Color.Fibos);

      CreateLine(GlobalPrefix + "LIDS11",Time[StartTime], Time[0],IntradayS1,IntradayS1,Color.Fibos,1);
      DisplayPrice = StringConcatenate("Intraday S1 ", IntradayS1);
      CreateText(GlobalPrefix + "LIDS12", DisplayPrice, IntradayS1, Color.Fibos);

      CreateLine(GlobalPrefix + "LIDST11",Time[StartTime], Time[0],IntradayShortT1,IntradayShortT1,Color.Fibos,1);
      DisplayPrice = StringConcatenate("Intraday Short T1 ", IntradayShortT1);
      CreateText(GlobalPrefix + "LIDST12", DisplayPrice, IntradayShortT1, Color.Fibos);

      CreateLine(GlobalPrefix + "LIDST21",Time[StartTime], Time[0],IntradayShortT2,IntradayShortT2,Color.Fibos,1);
      DisplayPrice = StringConcatenate("Intraday Short T2 ", IntradayShortT2);
      CreateText(GlobalPrefix + "LIDST22", DisplayPrice, IntradayShortT2, Color.Fibos);
      
   }
}//End void DrawFiboLines()

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void CreateLine(string name,datetime tfrom, datetime tto, double pfrom, double pto, color Col, int width)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, tfrom, pfrom,tto,pto);
            
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            //ObjectSet(name,OBJPROP_WIDTH,width);
            //ObjectSet(name,OBJPROP_RAY,RayLine);
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, tfrom, pfrom,tto,pto);
            
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            
            //ObjectSet(name, OBJPROP_COLOR, Col);        
            //ObjectSet(name,OBJPROP_WIDTH,width);
            //ObjectSet(name,OBJPROP_RAY,RayLine);
         }
}//End void CreateLine(string name,datetime tfrom, datetime tto, double pfrom, double pto, int width, color Col)



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateText(string TextName, string LabelText, double Price, color TextColor)
{
   if(ObjectFind(TextName) != 0)
   {
      ObjectCreate(TextName, OBJ_TEXT, 0, Time[0], Price);
      ObjectSetText(TextName, LabelText, 8, "Arial", TextColor);
   }
   else
      ObjectMove(TextName, 0, Time[0], Price);
}//End void CreateText(string TextName, string LabelText, double Price, color TextColor)  
*/


//+------------------------------------------------------------------+
//| Delete Objects that match ObjName                                |
//+------------------------------------------------------------------+
void DeleteEAObjects(string ObjName)
{
   for (int i=ObjectsTotal()-1; i >= 0; i--) 
   {
     string name = ObjectName(i);
     if (StringFind(name, ObjName) > -1) ObjectDelete(name);
   }
}//End void DeleteEAObjects(string ObjName)

//+------------------------------------------------------------------+


void BreakEvenStopLoss() 
{
   // Move stop loss to breakeven
   
   int ticket;

           
   if (OrderType()==OP_BUY)
         {
            if (Bid >= OrderOpenPrice () + (Poin*BreakEvenPips) && 
                OrderStopLoss()<OrderOpenPrice())
            {
               ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(BreakEvenProfit*Poin),OrderTakeProfit(),0,CLR_NONE);
               if (ticket>0 && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
            }
   	   }               			         
          
   if (OrderType()==OP_SELL)
         {
           if (Ask <= OrderOpenPrice() - (Poin*BreakEvenPips) &&
              (OrderStopLoss()>OrderOpenPrice()|| OrderStopLoss()==0)) 
            {
               ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(BreakEvenProfit*Poin),OrderTakeProfit(),0,CLR_NONE);
               if (ticket>0 && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
            }    
         }
      

} // End BreakevenStopLoss sub

bool PartCloseTradeFunction()
{
   // Called when any attempt to part-close a long trade is needed.
   // Trade has already been selected 
   // Returns 'true' if succeeds, else false, after setting a global variable to tell
   // the basket monitoring function that a closure failed and needs to be attempted
   // again.
   
   double price;
   if (OrderType()==OP_BUY) price = Bid;
   if (OrderType()==OP_SELL) price = Ask;
   
         
   bool result=OrderCloseReliableMKT(OrderTicket(), Close_Lots, price, 5, CLR_NONE);
   if (result)
   {
      if (ShowAlerts==true) Alert("Partial close of ", OrderSymbol(), " ticket no ", OrderTicket());
      return(true);
   }
   else
   {
      int err=OrderReliableLastErr();
      if (ShowAlerts==true) Alert("Partial close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",OrderReliableErrTxt(err));
      Print("Partial close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",OrderReliableErrTxt(err));
      return(false);
   }                          
   
}// End bool PartCloseTradeFunction()
   
void JumpingStopLoss() 
{
   // Jump sl by pips and at intervals chosen by user .
   // Also carry out partial closure if the user requires this

   // Abort the routine if JumpAfterBreakevenOnly is set to true and be sl is not yet set
   if (JumpAfterBreakevenOnly && OrderType()==OP_BUY)
   {
      if(OrderStopLoss()<OrderOpenPrice()) return(0);
   }
  
   if (JumpAfterBreakevenOnly && OrderType()==OP_SELL)
   {
      if(OrderStopLoss()>OrderOpenPrice()) return(0);
   }
  
   int ticket;
   double sl=OrderStopLoss(); //Stop loss

   if (OrderType()==OP_BUY)
   {
      // First check if sl needs setting to breakeven
      if (sl==0 || sl<OrderOpenPrice())
      {
         if (Ask >= OrderOpenPrice() + (JumpingStopPips*Poin))
         {
            sl=OrderOpenPrice();
            if (AddBEP==true) sl=sl+(BreakEvenProfit*Poin); // If user wants to add a profit to the break even
            if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
            {
               if (ShowAlerts==true) Alert("Jumping stop set at breakeven ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
               Print("Jumping stop set at breakeven: ", OrderSymbol(), ": StopLoss ", sl, ": Ask ", Ask);
               if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               {
                  bool PartCloseSuccess = PartCloseTradeFunction();
                  if (!PartCloseSuccess) SetAGlobalTicketVariable();
               }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))                        
            return(0);
         }//if (Ask >= OrderOpenPrice() + (JumpingStopPips*Poin))
      } //close if (sl==0 || sl<OrderOpenPrice()
   
      // Increment sl by sl + JumpingStopPips.
      // This will happen when market price >= (sl + JumpingStopPips)
      if (Bid>= sl + ((JumpingStopPips*2)*Poin) && sl>= OrderOpenPrice())      
      {
         sl=sl+(JumpingStopPips*Poin);
         if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
         {
            if (ShowAlerts==true) Alert("Jumping stop set at ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
            Print("Jumping stop set: ", OrderSymbol(), ": StopLoss ", sl, ": Ask ", Ask);
            if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
            {
               PartCloseSuccess = PartCloseTradeFunction();
               if (!PartCloseSuccess) SetAGlobalTicketVariable();
            }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
         }//if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
      }// if (Bid>= sl + (JumpingStopPips*Poin) && sl>= OrderOpenPrice())      
   }//if (OrderType()==OP_BUY)
   
   if (OrderType()==OP_SELL)
   {
        // First check if sl needs setting to breakeven
      if (sl==0 || sl>OrderOpenPrice())
      {
         if (Ask <= OrderOpenPrice() - (JumpingStopPips*Poin))
         {
            if (AddBEP==true) sl=sl-(BreakEvenProfit*Poin); // If user wants to add a profit to the break even
            if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
            {
               if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               {
                  PartCloseSuccess = PartCloseTradeFunction();
                  if (!PartCloseSuccess) SetAGlobalTicketVariable();
               }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))

            sl=OrderOpenPrice();
            if (AddBEP==true) sl=sl-(BreakEvenProfit*Poin); // If user wants to add a profit to the break even
            ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (ticket>0)
            {
               if (ShowAlerts==true) Alert("Jumping stop set at breakeven ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
               Print("Jumping stop set at breakeven: ", OrderSymbol(), ": StopLoss ", sl, ": Ask ", Ask);
               if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               {
                  PartCloseSuccess = PartCloseTradeFunction();
                  if (!PartCloseSuccess) SetAGlobalTicketVariable();
               }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (ticket>0)            
            return(0);
         }//if (Ask <= OrderOpenPrice() - (JumpingStopPips*Poin))
      } // if (sl==0 || sl>OrderOpenPrice()
   
      // Decrement sl by sl - JumpingStopPips.
      // This will happen when market price <= (sl - JumpingStopPips)
      if (Bid<= sl - ((JumpingStopPips*2)*Poin) && sl<= OrderOpenPrice())      
      {
         sl=sl-(JumpingStopPips*Poin);
         ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (ticket>0)
         {
            if (ShowAlerts==true) Alert("Jumping stop set at ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
            Print("Jumping stop set: ", OrderSymbol(), ": StopLoss ", sl, ": Ask ", Ask);
            if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
            {
               PartCloseSuccess = PartCloseTradeFunction();
               if (!PartCloseSuccess) SetAGlobalTicketVariable();
            }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
         }//if (ticket>0)          
      }// close if (Bid>= sl + (JumpingStopPips*Poin) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

} //End of JumpingStopLoss sub

int GetNextAvailableVariableNumber()
{
   // Called from the SetAGlobalTicketVariable() function.
   // Returns the first integer available.
   // The globla variable name consists of "GlobalVariableTicketNo" (stored in the 
   // string TicketName) and an integer.
         
   if (GlobalVariablesTotal()==0) return(1);
   
   for (int cc=1; cc > -1; cc++)
   {
      string ThisGlobalName = StringConcatenate(TicketName,DoubleToStr(cc,0));
      double v1 = GlobalVariableGet(ThisGlobalName);
      if(v1==0) return(cc);
      if (cc>100) return;
   }
   
}//End int GetNextAvailableVariableNumber()   

void TryPartCloseAgain()
{
   // Called if GlobalVariablesExist is set to true and global variables exist.
   // Attempts to part-close where a previous attempt failed
   
   string name;
   int index;
   int TicketNumber;
   for (int cc=0; cc < GlobalVariablesTotal(); cc++)
   {
      name = GlobalVariableName(cc);// Extract gv name
      index = StringFind(name,"ManagementGvTicketNo",0);// Is it relevent to this function?
      if (index>-1)// If so, then retry the part-close
      {
         TicketNumber = GlobalVariableGet(name);
         //Make sure trade was not closed previously
         if (OrderSelect(TicketNumber, SELECT_BY_TICKET) && OrderCloseTime() == 0)
         {
            bool PartCloseSuccess = PartCloseTradeFunction();
            if (PartCloseSuccess)
            {
               GlobalVariableDel(name);
               cc--;
            }//if (PartCloseSuccess)
         }//if (OrderSelect(), TicketNumber, SELECT_BY_POS)
         else
         {
            GlobalVariableDel(name);
            cc--;
         }
      }//if (index>-1)
   }//for (int cc=0; cc < GlobalVariablesTotal(); cc++)
}//End void TryPartCloseAgain()


void SetAGlobalTicketVariable()
{
   // Called whenever an attempt to part-close a trade fails.
   // This function finds the first available global variable name and sets up 
   // a gv with the ticket number of the offending trade. These gv's will consist of
   // the string TicketName ("GlobalVariableTicketNo") and an integer
   int cc = GetNextAvailableVariableNumber();
   string GlobalName=StringConcatenate(TicketName,DoubleToStr(cc,0));
   GlobalVariableSet(GlobalName, OrderTicket());
   ManagementGVsExist=true;
   
} // End void SetAGlobalTicketVariable();

void MonitorTrades()
{
   // This is a cut down version of MPTM and works the same way.
   
   for (int cnt=OrdersTotal(); cnt >= 0; cnt--)
   { 
      if (!OrderSelect(cnt, SELECT_BY_POS)) continue;
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol()) // Continue if order is correct symbol or the ea is to manage all trades regardless
      {                  
         // Is this trade being managed by the ea?
         if (EaManagesTrades) ManageTrade(); // The subroutine that calls the other working subroutines
         
      } // Close if (OrderSymbol()==Symbol())
      
   
   } // Close For loop

}// End void MonitorTrades()

void ManageTrade()
{
     
   // Call the working subroutines one by one. 

   // Global variable to pick up on failed part-closes
   if (GlobalVariablesTotal()>0) ManagementGVsExist=true;
   if (ManagementGVsExist && GlobalVariablesTotal()>0)  TryPartCloseAgain();
   if (ManagementGVsExist && GlobalVariablesTotal()==0) ManagementGVsExist=false;
      
   // Breakeven
   if(BreakEven) BreakEvenStopLoss();
   
   // JumpingStop
   if(JumpingStop) JumpingStopLoss();
   
   bool TradeStillOk = CheckOpenTradeStillOk(OrderType());
   if (!TradeStillOk)
   {
      CloseExistingTrade(OrderType());
   }//if (!TradeStillOk)
   
      
} // End of ManageTrade()

void CloseProfitableTradeBeforeNews()
{
   // Only called if OrdersTotal() > 0
   
   for (int cc = 0; cc < OrdersTotal(); cc++)
   {   
      if (OrderType() == OP_BUY || OrderType() == OP_SELL)
         {   
            if (OrderProfit() >=0) bool ticket = OrderCloseReliableMKT(OrderTicket(),OrderLots(), OrderClosePrice(),10,CLR_NONE);
            return;
         }//if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP))   
   }//for (int cc = 0; cc < OrdersTotal(); cc++)
      
}//End void CloseProfitableTradeBeforeNews()

bool NewsFilterCheck()
{
   // Checks for impending news events.
   // Closes open trades in profit or at be


   if(!IsTesting())
   {
      int  minutesUntilNextEvent = iCustom(NULL, 0, "FFCal", true, true, false, true, true, 1, 1);
      datetime dTime = minutesUntilNextEvent * 60;
      string sTime = TimeToStr(dTime, TIME_MINUTES);
      string sText;
      bool TradeAllowed = true;
      
      if (minutesUntilNextEvent>MinsUntilNews)//No news within the chosen timescale
      {
         sText = StringConcatenate("No News within the next ", sTime);
      }//if (minutesUntilNextEvent>MinsUntilNews)
      else
      {
         //News event within the chosen timescale
         int impactOfNextEvent = iCustom(NULL, 0, "FFCal", true, true, false, true, true, 2, 1);
         string sImpact = Num2Impact(impactOfNextEvent);
         if(StringLen(sImpact)>0) sImpact = "[" + sImpact + "] ";
         //sText = sImpact + "News in " + minutesUntilNextEvent + " mins.";
         sText = sImpact + "News in " + sTime;
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, sText, NL);
         //Should the robot suspend trading?
         if (impactOfNextEvent >= NewsImpact)
         {
            TradeAllowed = false;//Suspend trading
            if (CloseProfitableTrade && OrdersTotal() >0) CloseProfitableTradeBeforeNews();
            //Delete pending trades
         }//if (impact >= NewsImpact)
         
      }//else
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, sText, NL);
      return(TradeAllowed);
      
   }//if(!IsTesting())


}// End bool NewsFilterCheck()

string Num2Impact(int impact)
{
 if (impact == 3) return ("HIGH IMPACT");
 if (impact == 2) return ("MED IMPACT");
 if (impact == 1) return ("LOW IMPACT");
 else return ("");
}//End string Num2Impact(int impact)


bool CloseExistingTrade(int type)
{
   //Close an open trade
         
   if (OrdersTotal() == 0) return(true); //Nothing to do
   
   for (int cc = OrdersTotal(); cc > 0; cc--)
   {
      if(!OrderSelect(cc, SELECT_BY_POS, MODE_TRADES)) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == type)
      {
         bool result = OrderCloseReliableMKT(OrderTicket(), OrderLots(),OrderClosePrice(),5,CLR_NONE);
         if (!result)
         {
            int err=OrderReliableLastErr();
            if (ShowAlerts) Alert(OrderTicket(), " ", Symbol(), " OrderClose failed with error(",err,"): ",OrderReliableErrTxt(err));
            Print(OrderTicket(), " ", Symbol(), " OrderClose failed with error(",err,"): ",OrderReliableErrTxt(err));
            return(false);
         }//if (ticket < 0)
         else 
         {
            if (ShowAlerts) Alert(OrderTicket(), " ", Symbol(), " OrderClose");
            Print(OrderTicket(), " ", Symbol(), " OrderClose");            
            return(true);
         }//else
      }
   }//for (int cc = OrdersTotal(); cc > 0; cc--)
   
   // Got this far, so no trade to close so return true
   return(true);
   
}//End void CloseExistingTrade()


bool SendSingleTrade(int type)
{
   // Attempts to place a trade according to type, i.e.
   // 0 = OP_BUY
   // 1 = OP_SELL
   // 4 = OP_BUYSTOP
   // 5 = OP_SELLSTOP
   
    // Check spread
   if (MarketInfo(Symbol(), MODE_SPREAD) > MaxSpread)
   {
      return(false);// Spread too large, so abort send
   }//if (MarketInfo(NULL, MODE_SPREAD) > MaxSpread)

 
   // Calculates the tp/sl and stores them in Tp & Sl
   CalculateTpSl(type); 
//PendingDistancePips
   
   // Buy trade
   if (type == 0)
   {
      double TradePrice=Ask;
      int colour = 32768;//green
   }//if (type == 0)   
   
   
   // Sell trade
   if (type == 1)
   {
      TradePrice=Bid;      
      colour = 255;//red      
   }//if (type == 1)
   
   
   if (BrokerIs2stageCrook) int ticket = OrderSendReliable2Step(Symbol(),type, Lot, TradePrice, 5, Sl, Tp, TradeComment, MagicNumber,0, colour);
   else ticket = OrderSendReliableMKT(Symbol(),type, Lot, TradePrice, 5, Sl, Tp, TradeComment, MagicNumber,0, colour);
   if (ticket < 0)
   {
      int err=OrderReliableLastErr();
      Alert(Symbol(), " ", type," order send failed with error(",err,"): ",OrderReliableErrTxt(err));
      Print("Order send failed with error(",err,"): ",OrderReliableErrTxt(err));
      return(false);
   }//if (ticket < 0)
   else return(true);

}//End void SendSingleTrade(type)

void CalculateTpSl(int type)
{
   // Calculates the tp and sl for SendSingleTrade()
   
   // Leaving the auto stuff in place for now, in case I decide to include it later
   
   double spread = MarketInfo(Symbol(), MODE_SPREAD);
   
   // Long trades
   if (type == 0)
   {
      if (TakeProfit==0) Tp=0; 
      else Tp = NormalizeDouble(Bid + (TakeProfit * Poin),Digits);
      // TakeProfit based on ATR\ADX
      if (AutoCalculateTakeProfit)
      {
         // Calculate tp by getting ATR and using ADX to set the multiplier
         double AtrValue=iATR(Symbol(),0,AtrPeriod,0);
         if (iADX(Symbol(),0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) >20) AtrValue=AtrValue*4;
         if (iADX(Symbol(),0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) <=20) AtrValue=AtrValue*2;      
         Tp=MarketInfo(Symbol(),MODE_BID)+AtrValue;
                  
      }//if (AutoCalculateTakeProfit)

      if (StopLoss == 0) Sl = 0;
      else Sl = NormalizeDouble(Ask - (StopLoss * Poin) - (spread * Poin), Digits);
      if (AutoCalculateStopLoss)
      {
         /* Default auto-calculate code. Leave in place for now.
         AtrValue=iATR(Symbol(),0,AtrPeriod,0);
         Sl = NormalizeDouble(Ask - (AtrValue) - (spread * Poin), Digits);
         */
         // Cycle back and find the low of the previous swing, making this the sl
         Sl = iLow(NULL,0,0);
         for (int cc = 1; cc <= 10; cc++)
         {
            if (iClose(NULL,0,cc) < Sl) Sl = iClose(NULL,0,cc);
         }//for (int cc = 1; cc < 10; cc++)
                  
      }//if (AutoCalculateStopLoss)
   }//if (type == 0)

   
   // Short trades
   if (type == 1)
   {
      if (TakeProfit==0) Tp=0; 
      else Tp = NormalizeDouble(Ask - (TakeProfit * Poin),Digits);
      // TakeProfit based on ATR\ADX
      if (AutoCalculateTakeProfit)
      {
         // Calculate tp by getting ATR and using ADX to set the multiplier
         AtrValue=iATR(Symbol(),0,AtrPeriod,0);
         if (iADX(Symbol(),0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) >20) AtrValue=AtrValue*4;
         if (iADX(Symbol(),0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) <=20) AtrValue=AtrValue*2;
      
         Tp=MarketInfo(Symbol(),MODE_ASK)-AtrValue;
      }//if (AutoCalculateTakeProfit)
      
      if (StopLoss == 0) Sl = 0;
      else Sl = NormalizeDouble(Bid + (StopLoss * Poin) + (spread * Poin), Digits);
      if (AutoCalculateStopLoss)
      {
         /* Default auto-calculate code. Leave in place for now.
         AtrValue=iATR(Symbol(),0,AtrPeriod,0);
         Sl = NormalizeDouble(Bid + (AtrValue) + (spread * Poin), Digits);
         */
         // Cycle back and find the high of the previous swing, making this the sl
         Sl = iHigh(NULL,0,0);
         for (cc = 1; cc <= 10; cc++)
         {
            if (iClose(NULL,0,cc) > Sl) Sl = iClose(NULL,0,cc);
         }//for (int cc = 1; cc < 10; cc++)
                  
      }//if (AutoCalculateStopLoss)
   }//if (type == 1)
   
   
   
}//void (CalculateTpSl(int type)

double ReadStochastic()
{
   // Returns the value of Stoch indi. Uses the indi defaults
   
   double StochVal = iStochastic(NULL, 0, 8, 3, 3, 0, 1, MODE_MAIN, 0);
   return(StochVal);
   
}//End double ReadStochastic(string symbol)


bool DoesTradeExist()
{
   // Returns true if a trade already exists, false if not
   
   if (OrdersTotal() == 0) return(false); // NOthing to do
   
   for (int cc = 0; cc < OrdersTotal(); cc++)
   {
      OrderSelect(cc,SELECT_BY_POS);
      ReturnedTicketNo=(OrderTicket());
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) return(true);
   }//for (int cc = 0; cc < OrdersTotal(); cc++)

   // Got this far, so trade does not exist
   return(false);
}// End bool DoesTradeExist()

void TradesTotal()
{
   // Calculates the number of DC trades open and their profit. Used for display and global closure purposes
   
   TradesProfit=0;
   TradesOpen=0;
   
   if (OrdersTotal() == 0) return;//Nothing to do
   
   for (int cc = 0; cc < OrdersTotal(); cc++)
   {
      OrderSelect(cc, SELECT_BY_POS);
      if (OrderMagicNumber() == MagicNumber)
      {
         TradesProfit = TradesProfit + OrderProfit();
         TradesOpen++;
      }//if (OrderMagicNumber == DcMagicNumber)
   }//for (int cc = 0; cc < OrdersTotal(); cc++)

}//void TradesTotal()

/*void ReturnMacdTrend()
{
   //Sets HigherTrendDirection to 0 for uptrend, 1 for short trend, 2 for no trend.
   //Trend requirements: value for long must be >MinMacdValue and rising for MacdLookBackBars, vice versa for short
   
   if (!UseMACD) return;
   
   //Check long trend
   bool LongTrend = true;
   for (int cc = 1; cc <= MacdLookBackBars; cc++)
   {
      if (iMACD(NULL, TimePeriod, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, cc) < MinMacdValue)
      {
         LongTrend = false;
         break;
      }//if (iMACD(NULL, TimePeriod, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, cc) < MinMacdValue)      
   }//for (int cc = 1; cc < MacdLookBackBars; cc++)
   if (LongTrend) 
   {
      HigherTrendDirection=0;
      return;
   }//if (LongTrend) 
   
   //Check Short trend
   bool ShortTrend = true;
   for (cc = 1; cc <= MacdLookBackBars; cc++)
   {
      if (iMACD(NULL, TimePeriod, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, cc) > -MinMacdValue)
      {
         ShortTrend = false;
         break;
      }//if (iMACD(NULL, TimePeriod, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, cc) < MinMacdValue)      
   }//for (int cc = 1; cc < MacdLookBackBars; cc++)
   if (ShortTrend) 
   {
      HigherTrendDirection=1;
      return;
   }//if (ShortTrend)
    
   //Got this far, so no trend established
   HigherTrendDirection=2;
   
}//End void ReturnMacdTrend()*/

/*void ReturnPsarTrend()
{
   //Sets HigherTrendDirection to 0 for uptrend, 1 for short trend, 2 for no trend.
   //Trend requirements: Markets must close above PSAR for long, below for short

   if (!UsePSAR) return;
   
   //Check long trend
   bool LongTrend = true;
   for (int cc = 1; cc <= PsarLookBackBars; cc++)
   {
      if (iClose(NULL, TimePeriod,cc) < iSAR(NULL,TimePeriod,0.05,0.2,cc))
      {
         LongTrend = false;
         break;
      }//if (Close[cc] < iSAR(NULL,TimePeriod,0.05,0.2,cc))
   }//for (int cc = 1; cc < PsarLookBackBars; cc++)
   if (Ask < iSAR(NULL,TimePeriod,0.05,0.2,0)) LongTrend=false;
   if (LongTrend) 
   {
      HigherTrendDirection=0;
      return;
   }//if (LongTrend) 
   
   
   //Check Short trend
   bool ShortTrend = true;
   for (cc = 1; cc <= PsarLookBackBars; cc++)
   {
      if (iClose(NULL, TimePeriod,cc) > iSAR(NULL,TimePeriod,0.05,0.2,cc))
      {
         ShortTrend = false;
         break;
      }//if (Close[cc] > iSAR(NULL,TimePeriod,0.05,0.2,cc))
   }//for (int cc = 1; cc < PsarLookBackBars; cc++)        
   if (Bid > iSAR(NULL,TimePeriod,0.05,0.2,0)) ShortTrend=false;
   if (ShortTrend) 
   {
      HigherTrendDirection=1;
      return;
   }//if (ShortTrend)
   
   
   
   //Got this far, so no trend established
   return(2);
   

}//End void ReturnPsarTrend()*/

/*void GetCurrentFibBand()
{
   //Gets the fib band that contains the market price 
   
//double            FibBandHigh, FibBandLow;//Fib levels that surround the market price

   //Take care of prices already outside the fib area. Set a level to -1 to tell the robot not to trade
   if (Ask >= IntradayLongT2)
   {
      FibBandHigh = -1;
      FibBandLow = -1;
      return;
   }//if (Ask > IntradayLongT2) 
   
   if (Ask <= IntradayShortT2)
   {
      FibBandHigh = -1;
      FibBandLow = -1;
      return;
   }//if (Bid < IntradayShortT2}
   
   //Now go through the rest of the levels and set high\low of the band accordingly
   if (Ask >= IntradayShortT2 && Ask <= IntradayShortT1)
   {
      FibBandHigh = IntradayShortT1;
      FibBandLow = IntradayShortT2;
      return;
   }//if (Ask > IntradayShortT2 && Ask > IntradayShortT1)
   
   if (Ask >= IntradayShortT1 && Ask <= IntradayLow)
   {
      FibBandHigh = IntradayLow;
      FibBandLow = IntradayShortT1;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayLow && Ask <= IntradayS1)
   {
      FibBandHigh = IntradayS1;
      FibBandLow = IntradayLow;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayS1 && Ask <= IntradayShort)
   {
      FibBandHigh = IntradayShort;
      FibBandLow = IntradayS1;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayShort && Ask <= IntradayPivot)
   {
      FibBandHigh = IntradayPivot;
      FibBandLow = IntradayShort;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayPivot && Ask <= IntradayLong)
   {
      FibBandHigh = IntradayLong;
      FibBandLow = IntradayPivot;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayLong && Ask <= IntradayR1)
   {
      FibBandHigh = IntradayR1;
      FibBandLow = IntradayLong;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayR1 && Ask <= IntradayHigh)
   {
      FibBandHigh = IntradayHigh;
      FibBandLow = IntradayR1;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayHigh && Ask <= IntradayLongT1)
   {
      FibBandHigh = IntradayLongT1;
      FibBandLow = IntradayHigh;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
   if (Ask >= IntradayLongT1 && Ask <= IntradayLongT2)
   {
      FibBandHigh = IntradayLongT2;
      FibBandLow = IntradayLongT1;
      return;
   }//if (Ask > IntradayShortT1 && Ask > IntradayLow)
   
 
   
}//End void GetCurrentFibBand()*/
   
bool CheckFilters(int type)
{
   // Returns true if all the trade filters line up, else returns false

   /*// Check Volume
   if (UseVolume)
   {
      if (Volume[1] < Volume[2]) return(false);
      if (Volume[2] < Volume[3]) return(false);
   }//if (UseVolume)
   
   //Current Fibo band
   if (UseFibs)
   {
      GetCurrentFibBand();
      if (FibBandHigh == -1 || FibBandLow == -1) return(false);
   }//if (UseFibs)
   

   //Set up MA's
   if (UseMA)
   {
      double FastMaPrice = iMA(NULL,0, FastMA,0,MODE_EMA,PRICE_CLOSE,0);
      double SlowMaPrice = iMA(NULL,0, SlowMA,0,MODE_SMA,PRICE_CLOSE,0);      
   }//if (UseMA)*/
      
   
   //Check for long trade
   if (type == 0)
   {
      //Stoch
      if (UseStochastic)
      {
         double StochVal = ReadStochastic();
         if (StochVal > StochOverBought) return(false);
         double StochMain = iStochastic(NULL, 0, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, 0);
         double StochSignal = iStochastic(NULL, 0, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, 0);
         if(StochMain < StochSignal) return(false);
      }//if (UseStochastic)
      
      //AO
      if (iAO(NULL,0,0) < iAO(NULL,0,1)) return(false);
      if (iAO(NULL,0,1) < iAO(NULL,0,2)) return(false);

      //AC
      if (iAC(NULL,0,0) < iAC(NULL,0,1)) return(false);
      if (iAC(NULL,0,1) < iAC(NULL,0,2)) return(false);
      
      // Up candle
      if (Close[1] < Open[1])  return(false);
      
      /*//MA
      if (UseMA)
      {
         if (FastMaPrice <= SlowMaPrice) return(false);
      }//if (UseMA)
      
      //Fibs.
      if (UseFibs)
      {
         if (FibBandHigh - Ask < MinPipsToNextLevel * Poin) return(false);
      }//if (UseFibs)*/
      
      
   }//if (type == 0)
   
   
   //Check for short trade
   if (type == 1)
   {
      //Stoch
      if (UseStochastic)
      {
         StochVal = ReadStochastic();
         if (StochVal < StochOverSold) return(false);
         StochMain = iStochastic(NULL, 0, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, 0);
         StochSignal = iStochastic(NULL, 0, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, 0);
         if(StochMain > StochSignal) return(false);
      }//if (UseStochastic)
      
      //AO
      if (iAO(NULL,0,0) > iAO(NULL,0,1)) return(false);
      if (iAO(NULL,0,1) > iAO(NULL,0,2)) return(false);
      
      //AC
      if (iAC(NULL,0,0) > iAC(NULL,0,1)) return(false);
      
      // Down candle
      if (Close[1] > Open[1]) return(false);
      
      /*//MA
      if (UseMA)
      {
         if (FastMaPrice >= SlowMaPrice) return(false);
      }//if (UseMA)
      
      
      //Fibs.
      if (UseFibs)
      {
         if (Bid - FibBandLow  < MinPipsToNextLevel * Poin) return(false);
      }//if (UseFibs)*/
            
   }//if (type == 1)   
   
   //Got this far, so everything lines up
   return(true);
   
}// End bool CheckFilters(int type)

bool CheckOpenTradeStillOk(int type)
{
   // Returns true if the trade filters still line up, else returns false
   
   //Check long trade
   if (type == 0)
   {
      
      //AO
      if (iAO(NULL,0,1) < iAO(NULL,0,2)) return(false);
      
      //PSAR
      if (iClose(NULL,0,1) < iSAR(NULL,0,0.05,0.2,1)) return(false);
      
   }//if (type == 0)
   
   
   //Check short short trade
   if (type == 1)
   {
      
      //AO
      if (iAO(NULL,0,1) > iAO(NULL,0,2)) return(false);
      
      //PSAR
      if (iClose(NULL,0,1) > iSAR(NULL,0,0.05,0.2,1)) return(false);
      
   }//if (type == 1)   
   
   //Got this far, so everything lines up
   return(true);
   
}// End bool CheckOpenTradeStillOk(int type)

bool CheckForGlobalVariable()
{
   //Returns true if there is a trade-pending global, else returns false
   
   if (GlobalVariableCheck(GvName)) return(true);
   else return(false);
   
   
}//End bool CheckForGlobalVariable()


bool HasSarsChangedDirection()
{
   // Sets a gv with the appropriate trade direction and returns true if SARS has changed direction, else returns false
   
   //Change long
   if (TradeLong)
   {
      //if (iClose(NULL,0,1) > iSAR(NULL,0,0.05,0.2,1) && iClose(NULL,0,2) < iSAR(NULL,0,0.05,0.2,2))
      if (Ask > iSAR(NULL,0,0.05,0.2,0) && iClose(NULL,0,1) < iSAR(NULL,0,0.05,0.2,1))
      {
         //Call the higher tf filters. Each called function aborts if the user does not want it
         //HigherTrendDirection = 0;// Gets reset if higher trend is not long
         //ReturnMacdTrend();
         //if (HigherTrendDirection != 0) return(false);
         //ReturnPsarTrend();
         //if (HigherTrendDirection != 0) return(false);
         //Got this far, so set the GV
         GlobalVariableSet(GvName, 0); //0=buy
         return(true);
      }//if (iClose(NULL,0,1) > iSAR(NULL,0,0.05,0.2,1) && iClose(NULL,0,2) < iSAR(NULL,0,0.05,0.2,2))
   }//if (TradeLong)
   
   //Change short
   if (TradeShort)
   {   
      //if (iClose(NULL,0,1) < iSAR(NULL,0,0.05,0.2,1) && iClose(NULL,0,2) > iSAR(NULL,0,0.05,0.2,2))
      if (Bid < iSAR(NULL,0,0.05,0.2,0) && iClose(NULL,0,1) > iSAR(NULL,0,0.05,0.2,1))
      {
         //HigherTrendDirection = 1;// Gets reset if higher trend is not short
         //ReturnMacdTrend();
         //if (HigherTrendDirection != 1) return(false);
         //ReturnPsarTrend();
         //if (HigherTrendDirection != 1)return(false);
         //Got this far, so set the GV
         GlobalVariableSet(GvName, 1); //1=sell
         return(true);
      }//if (iClose(NULL,0,1) < iSAR(NULL,0,0.05,0.2,1) && iClose(NULL,0,2) > iSAR(NULL,0,0.05,0.2,2))
   }//if (TradeShort)
   
   //Got this far, so result is false
   return(false);

}//End bool HasSarsChangedDirection()

bool CheckGvStillValid()
{
   //Checks the validity of a global. The gv has to exist for this routine to be called.
   // GV will be invalid if psar has flipped in the opposite direction.
   // Called at the start of each candle, so examines the psar of the close of the previous one
   // Also returns invalid if UseMA is true and the ma's are moving in the wrong direction
   // Deletes the GV if invalid
   
   int type = GlobalVariableGet(GvName);
   bool GvStillValid = true;
   
   /*//Set up MA's
   if (UseMA)
   {
      double FastMaPrice = iMA(NULL,0, FastMA,0,MODE_EMA,PRICE_CLOSE,0);
      double SlowMaPrice = iMA(NULL,0, SlowMA,0,MODE_SMA,PRICE_CLOSE,0);      
   }//if (UseMA)*/

   
   //Long
   if (type == 0)
   {
      if (Ask < iSAR(NULL,NULL,0.05,0.2,1)) GvStillValid = false;   
      /*//MA
      if (UseMA)
      {
         if (FastMaPrice < SlowMaPrice) GvStillValid = false;
      }//if (UseMA)*/
   }//if (type == 0)
   
   //Short
   if (type == 1)
   {
      if (Bid > iSAR(NULL,NULL,0.05,0.2,1)) GvStillValid = false;
      //MA
      /*if (UseMA)
      {
         if (FastMaPrice > SlowMaPrice) GvStillValid = false;
      }//if (UseMA) */
   }//if (type == 1)  
   
   if (!GvStillValid) GlobalVariableDel(GvName);
   
   //Got this far, so global is still valid.
   return(GvStillValid);
   
}//End bool CheckGvStillValid()

void AutoCalculateLotSize()
{
   // Money management - Define suitable lotsize - written by Chrisstoff and adapted here.
   // My appreciation for this to Chrisstoff.
   
   double Lotsi;//My adaptation
   int Decimals;//My adaptation

   double AcctLeverage    = AccountLeverage();
   double MinLotSize      = MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLotSize      = MarketInfo(Symbol(),MODE_MAXLOT);
   double LotStep         = MarketInfo(Symbol(),MODE_LOTSTEP);
   double CurrencyLotSize = MarketInfo(Symbol(),MODE_LOTSIZE);
   int Spread             = MarketInfo(Symbol(),MODE_SPREAD);
   if(LotStep == 0.01) {Decimals = 2;}
   if(LotStep == 0.1)  {Decimals = 1;}
   if(LotStep == 1)    {Decimals = 0;}
          
   //No stop loss, so use this routine
   if (!AutoCalculateStopLoss && StopLoss == 0)  Lotsi = AccountEquity() * (RiskPercent * 0.01) / (CurrencyLotSize / AcctLeverage);
   
   //Autocalculated or manually enterred
   if (!AutoCalculateStopLoss) Sl = StopLoss;
   //double lot = (equity / stop) * (risk * 0.01);
   Lotsi = (AccountEquity() / Sl) * (RiskPercent * 0.01);
   
   
   Lotsi = StrToDouble(DoubleToStr(Lotsi,Decimals));
     
   if (Lotsi < MinLotSize) {Lotsi = MinLotSize;}
   if (Lotsi > MaxLotSize) {Lotsi = MaxLotSize;}   

   Lot = Lotsi;//My adaptation

}//void AutoCalculateLotSize()

bool ShouldRobotSleep()
{
   // Checks the history list to find a closed trade.
   // If one exists, checks to see if it closed more than SleepAfterTradeClosesMins.
   // Returns false (sleep not needed) if so, else true (sleep needed)
   
   if (OrdersHistoryTotal() == 0) return(false);// No history trades, so sleep clearly not needed
   
   for(int cnt=0; cnt<OrdersHistoryTotal(); cnt++)
   {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)) continue;
      {       
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         {
            int TimePassed = (TimeCurrent() - OrderCloseTime()) / 60;
            if (TimePassed < SleepAfterTradeClosesMins) return(true);//Robot should sleep
         }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)            
      }//if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
   }//for(int cnt=0; cnt<OrdersHistoryTotal(); cnt++)

   //Got this far, so sleep not needed
   return(false);

}//bool ShouldRobotSleep()

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   if (RobotDisabled) return;//Cannot trade without a magic number

   // Ad up the total number of trades made by this EA, and calculate their profit
   if (OrdersTotal() > 0) TradesTotal();
   

   /*// New period, so re-calculate Fib levels etc
   if (OldBars != Bars && UseFibs)
   {
      Prior_Time_D1 = iTime(Symbol(),PERIOD_D1,1);
      Calc_FiboPivots(); 
      DrawFiboLines();
   }//if (OldBars != Bars)*/



   // On-screen display of relevant information
   DisplayUserFeedback();

   // Existing trade management
   if (OrdersTotal() > 0 && EaManagesTrades) MonitorTrades();


   //News events
   if (UseNewsFilter) 
   {
      bool NotNews = NewsFilterCheck();
      if (!NotNews)
      {   
         return;
      }   
   }//if (UseNewsFilter)   

   
   // Trading time filters
   // Sunday candle
   if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal())==0)
   {
      GlobalVariableDel(GvName);
      return;
   }//if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal())==0)
   
   //Monday start
   if (TimeDayOfWeek(TimeLocal())==1 && TimeHour(TimeLocal()) < MondayStartHour) 
   {
      GlobalVariableDel(GvName);
      return;
   }//if (TimeDayOfWeek(TimeLocal())==1 && TimeHour(TimeLocal()) < MondayStartHour) 
      
   //Friday shut down
   if (StopTradingOnFriday)
   {
      if (TimeDayOfWeek(TimeLocal())==5)
      {   
         if (TimeHour(TimeLocal()) >= FridayStopHour)
         {
            GlobalVariableDel(GvName);
            return;
         }//if (TimeHour(TimeCurrent()) >= FridayStopHour)   
      }//if TimeDayOfWeek(TimeCurrent()==5)   
   }//if (StopTradingOnFriday)

 
   // Check for existing trade.
   // Saves ticket no of existing trade in ReturnedTicketNo
   bool TradeExists = DoesTradeExist();
   if (TradeExists) return;
   
   // No open trade, so check that the last trade closed long enough ago to allow fresh trading
   // Code to send the robot to sleep after a trade closure
   bool SendToSleep = ShouldRobotSleep();// Compares closure time of history trade with current time, 
                                         // returning true for sleep or false. Will return false if no history trades
   if (SendToSleep)
   {
      Comment("Sleeping after trade closure");
      Sleep((SleepAfterTradeClosesMins*60)*1000);
   }//if (SendToSleep)
   
   
   // No trade exists so check for PSAR change stored in a global variable
   bool GvExists = CheckForGlobalVariable();
   
   // Delete the gv if psar has flipped since the gv was set.
   // CheckGvStillValid() returns true if still valid, else false if invalid, in which case it will be deleted by the checking function.
   // Check at the start of the new candle
   //if (OldBars != Bars  && GvExists) 
   if (GvExists) 
   {
      bool StillValid = CheckGvStillValid();
      if (!StillValid)
      {
         GvExists = false;
      }//if (!StillValid)
      //else OldBars = Bars;
   }//if (OldBars != Bars  && GvExists) 
   
   //If PSAR has not signalled a trade, then check for one at the start of each new candle
   //if (OldBars != Bars  && !GvExists)
   if (!GvExists)
   {
      bool SarsChanged = HasSarsChangedDirection();// Seta a gv with the appropriate trade direction and returns true if SARS has changed direction
      if (SarsChanged) bool TradeAllowed = true;
      GvExists=true;
      //OldBars = Bars;
   }//if (OldBars != Bars)
   
   //If PSAR has signalled a trade, check remaining filters. The function returns true if they line up, else false
   if (GvExists) 
   {
      int type = -1;
      type = GlobalVariableGet(GvName);
      TradeAllowed = CheckFilters(type);
   }//if (GvExists) 

    
   // All filters are lined up, so send the trade
   if (TradeAllowed && type > -1)
   {
      if (RobotCalcLotSize) AutoCalculateLotSize();//Resets Lots according to the mm rules
      
      if (type == 0 && TradeLong) bool TradeSuccess = SendSingleTrade(OP_BUY);
      
      if (type == 1 && TradeShort) TradeSuccess = SendSingleTrade(OP_SELL);
      
      if (TradeSuccess) GlobalVariableDel(GvName);
         
   }//if (TradeAllowed)

//----
   return(0);
}// End int start()


